<?php
/*
** This file contain all things for the drink post type, like shortcodes and functions
**
** To this posttype belongs this files:
**
** - drink-entry.php
** - drink-list-item.php
** - drink-menu-grid.php
** - drink-menu-list.php
** - drink-menu-simple-list.php
** - drink-simplelist-item.php
** - taxonomy-drink-type.php
**
*/

if ( function_exists( 'add_theme_support' ) ) 
	{ 
	add_theme_support( 'post-thumbnails' );
	set_post_thumbnail_size( 280, 210, true ); // Normal post thumbnails
	add_image_size( 'drink-mini', 330, 330, true );
	add_image_size( 'drink-default', 500, 500, true );
	add_image_size( 'drink-icon', 80, 80, true );
	}  
function drink_register() 
	{  
    	$args = array(  
        	'label' => 'Drinks',  
        	'singular_label' => 'Drinks',  
        	'public' => true,  
        	'show_ui' => true,  
        	'capability_type' => 'post',  
        	'hierarchical' => false,  
        	'rewrite' => true,  
        	'supports' => array('title', 'editor', 'thumbnail','post-types') ,
		'show_in_menu' => true  ,
		 'menu_position' => null,
       	);  
    	register_post_type( 'drink' , $args );  
	}  
	add_action('init', 'drink_register');  



register_taxonomy("drink-type", array("drink"), array("hierarchical" => true, "label" => "Ingredients", "singular_label" => "Drink Type", "rewrite" => true));
register_taxonomy("drink-tag", array("drink"), array("hierarchical" => true, "label" => "Category", "singular_label" => "Drink Category", "rewrite" => true));





function drink_mini_url($pid)
	{	
	$image_id = get_post_thumbnail_id($pid); 	
	$image_url = wp_get_attachment_image_src($image_id,'drink-mini'); 
	return  $image_url[0];  
	}
function drink_default_url($pid)
	{	
	$image_id = get_post_thumbnail_id($pid); 	
	$image_url = wp_get_attachment_image_src($image_id,'drink-default'); 
	return  $image_url[0];  
	}
function drink_icon_url($pid)
	{	
	$image_id = get_post_thumbnail_id($pid); 	
	$image_url = wp_get_attachment_image_src($image_id,'drink-icon'); 
	return  $image_url[0];  
	}












add_action("admin_init", "drink_meta_box"); 

function drink_meta_box()
	{  
	add_meta_box("drinkInfo-meta", "Drink Options", "drink_meta_options", "drink", "side", "low");  
	}   
function drink_meta_options()
	{  
	        global $post;  
	        if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post_id;
	        $custom = get_post_custom($post->ID);  
		if(isset($custom["drinkPrice"][0]))
			{
		        	$price = $custom["drinkPrice"][0];		
			}
		if(isset($custom["drinkBestseller"][0]))
			{
		        	$bestseller = $custom["drinkBestseller"][0];        
			}
	?>  
	<ul>
		<li><label for="drinkPrice">Price:</label><input id="drinkPrice" name="drinkPrice" value="<?php if(isset($price)) { echo $price; }  ?>" /></li> 
		<li><label for="Bestseller"><input id="Bestseller" type="checkbox" name="Bestseller" <?php if(isset($bestseller)) { echo " checked"; }  ?> /> Mark as Bestseller</label></li>
	</ul>
	<?php  
	}  
	add_action('save_post', 'save_drink_meta');  
function save_drink_meta()
	{  
	    global $post;  
	    if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
		{ 
		return $post_id;
		}	
		else
			{
			if(isset($_POST["drinkPrice"]))
				{
			    	update_post_meta($post->ID, "drinkPrice", $_POST["drinkPrice"]);  
				}
			if(isset($_POST["Bestseller"]))
				{
			    	update_post_meta($post->ID, "drinkBestseller", $_POST["Bestseller"]);  	
				}
			} 
		}   






 








/*
** SHORTCODES
*/



///////////////////////
/////////// DRINK SLIDER
//////////////////////

function drinkslider($atts, $content=null)
	{
	extract(shortcode_atts(array(
	'buttons'=>true,
	'speed'=>'1000',
	'width'=>'',
	'height'=>'',
	'easing'=>'',
	'items'=>'10',
	'itemsforward'=>'4',
	'pauseonhover'=>'true', 
	'direction'=>'left',
	'columns'=>'3',
	'price'=>'false',
	'showtext'=>'false',
	'readmore'=>'false',
	'headline'=>'false',
	'price'=>'false',
	'right'=>'20',
	'number'=>'10',
	'auto'=>'false',
	'category'=>''
	    ), $atts));
	$return="";
	$ix="";
	if($speed=="")	
		{
		$speed="1000";
		}

	$rand=substr(str_shuffle(str_repeat('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz',5)),0,5);
	$return="<div id='carousel-".$rand."' class='carousel-container'>";
	$half_height=$height/2;	
	$return.="<style type='text/css' scoped><!-- #".$rand." .drink-lists-item-shortcode {display:inline-block; width:".$width."px; margin-right:".$right."px;}";
	$return.=" #carousel-".$rand."  .carousel-nav {top:".$half_height."px;}";
	if($height!="")
		{
		$return.=" #".$rand." {height:".$height."px;} #".$rand." li, #".$rand." > div {  height:".$height."px;}";
		}
	if($width!="")
		{
		$return.=" #".$rand." ul li, #".$rand." > div {width:".$width."px; }";
		}
	$return.="--></style>";	
	if($buttons=="true")
		{	
		$return.="<a id='".$rand."-prev' class='carousel-nav carousel-nav-prev' onclick='return false' href='#'>&lt;</a>
			<a id='".$rand."-next' class='carousel-nav carousel-nav-next' onclick='return false' href='#'>&gt;</a>";
		}
	$return.="<ul class='carousel' id='".$rand."'>";



	switch ($columns)
		{
		case 1: $cols=""; break;
		case 2: $cols="one_half"; break;
		case 3: $cols="one_third"; break;
		case 4: $cols="one_fourth"; break; 
		}
	if($type!="")
		{
		$args = array( 'numberposts' => $number, 'post_type'=>'drink','post_status' => 'publish', 'drink-tag'=>$category);
		}
		else
			{
			$args = array( 'numberposts' => $number, 'post_type'=>'drink','post_status' => 'publish');
			}
	global $post;
	$price_name=load_option("price_name");
	$price_currency=load_option("price_currency");
	$myposts = get_posts( $args );
	foreach( $myposts as $post ) :	setup_postdata($post);  
	$ix++; 	
	$title= str_ireplace('"', '', trim(get_the_title()));
	$desc= str_ireplace('"', '', trim(get_the_content()));			 
	$return.='	<li class="ex-'.$cols.  ' drink-lists-item-shortcode">';
    	ob_start();  
    	get_template_part("drink-entry");  
    	$ret = ob_get_contents();  
    	ob_end_clean();  
   	$return.= $ret;  
	$return.="</li>";
	endforeach;
	wp_reset_query();
	$return.="</ul>";
	$return.="<script type='text/javascript'>
		<!--//--><![CDATA[//><!--
		jQuery(window).load(function()
			{
			jQuery('#carousel-".$rand." .carousel ').carouFredSel({
				items               	: ".$items.",
				direction           	: '".$direction."',
				";
			if($height!="")
				{
				$return.="height		: '".$height."', "; 
				}
	$return.="				
				prev		: '#".$rand."-prev',
				next		: '#".$rand."-next',";
	if($auto!="true")
		{
		$return.="
				auto :
					{
					play:	false 
					},
			";
		}
	$return.="		scroll : 
					{	";
	if($easing!="")
		{
		$return.="	easing		: '".$easing."', ";
		}
	$return.="
		            			items           : ".$itemsforward.",
		            			duration        : ".$speed.",                  
	            				pauseOnHover    : true
	        				} 
				 });
			";
	if($height!="")
		{
		$return.="			jQuery('#".$rand."').parent().height('".$height."');";
		}
	$return.="
			});
		//--><!]]>
		</script>";
	$return.="</div>";
	$return.="<div class='clear'></div>";
	return $return;		
	}
	add_shortcode('drinkslider', 'drinkslider');



///////////////////
////// DRINK GRID
///////////////////

function drink_grid($atts, $content=null)
	{
	extract(shortcode_atts(array(  
	'items'=>'10', 
	'columns'=>'3', 
	'category'	=>'',
	    ), $atts)); 
	$return="";
	$group_cat="";
	$cols=$columns;
	ob_start();
	?>
		<div class="group">
		<div class="portfolio-itemlist-col<?php echo $cols; ?> group-itemlist-<?php echo $cols; ?>">
		<?php $ix=0; 
		query_posts(array( 'post_type' => 'drink', 'paged' => get_query_var('paged'), 'posts_per_page'=>$items ,   'drink-tag'=>$category ) ); 
		?>
		<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
			<?php $ix++; ?>
			<?php
			if($ix>1)
				{
				$last="_last";
				$clear="<div class='clear'></div>";
				$ix=0;
				}
				else
					{
					$last="";	
					$clear="";
					}
			$title= str_ireplace('"', '', trim(get_the_title()));
			$desc= str_ireplace('"', '', trim(get_the_content()));
 
			?>
			<div class="portfolio-lists-item">
				<?php get_template_part("drink-entry"); ?>
			</div>

		<?php 	
			$clear="";
			if($ix>=$cols)
				{
				$ix=0;
				$clear=" clear";
				}

			endwhile; 
		endif; ?>		 
		</div><!-- portfolio-itemlist-col2 -->
		<div class="clear"></div>
	</div><!-- group-->  

	<?php 
    	$ret = ob_get_contents();  
    	ob_end_clean();  
	wp_reset_query(); 
	$return.=$ret;
	return $return;
	}
	add_shortcode("drink_grid","drink_grid");



function add_drinkslider_shortcode()
	{
	echo ' 				<h3><a href="#">Drink Slider</a></h3>		
				<div>
					<label for="drink_number">Number of Items</label>
					<input type="text" name="drink_number" value="" id="drink_number" /><br />
					<label for="drink_items">Visible items</label>
					<input type="text" name="drink_items" value="" id="drink_items" /><br />	
					<label for="drink_forward">Number of Items go forward</label>
					<input type="text" name="drink_forward" value="" id="drink_forward" /><br />
					<label for="drink_width">Width of sliding element</label>
					<input type="text" name="drink_width" value="" id="drink_width" /><br />
					<label for="drink_height">Height of sliding element</label>
					<input type="text" name="drink_height" value="" id="drink_height" /><br />
					<label for="drink_right">Sliding element, distanze to the Right</label>
					<input type="text" name="drink_right" value="" id="drink_right" /><br />
					<label for="drink_headline">Show Headline?</label>
					<input type="checkbox" name="drink_headline" value="" id="drink_headline" /><br />
					<label for="drink_text">Show Text?</label>
					<input type="checkbox" name="drink_text" value="" id="drink_text" /><br />
					<label for="drink_readmore">Show Readmore Button?</label>
					<input type="checkbox" name="drink_readmore" value="" id="drink_readmore" /><br /> 
					<label for="drink_price">Show Price?</label>
					<input type="checkbox" name="drink_price" value="" id="drink_price" /><br /> 
					<label for="drink_dir">Direction</label>
					<select name="drink_dir" value="" id="drink_dir" >
						<option></option>
						<option value="left">Left</option>
						<option value="right">Right</option>
						<option value="up">Up</option>
						<option value="down">Down</option>
					</select>
					<label for="drink_auto">Autostart the Show?</label>
					<input type="checkbox" name="drink_auto" value="" id="drink_auto" /><br /> 
					<label for="drink_speed">Pause between Change in Millisecondes</label>
					<input type="text" name="drink_speed" id="drink_speed"><br />
					<label for="drink_cat">Show only Items from this Category:</label>
					<input type="text" name="drink_cat" id="drink_cat"><br />
					<br />
					<a href="javascript:DrinkDialog.insert(DrinkDialog.local_ed)" class="updateButton" style="display: block; line-height: 24px;">Insert</a>
				</div>	';
	}
add_action("shortcode_generator_contentslider_tab","add_drinkslider_shortcode");






function add_drinkslider_shortcode_script()	
	{
	echo "<script type='text/javascript'> 
var DrinkDialog = {
	local_ed : 'ed',
	init : function(ed) {
	DrinkDialog.local_ed = ed;
		tinyMCEPopup.resizeToInnerSize();
	},
	insert : function insertdrink(ed) {
		var drink_cat;
		var drink_dir='right';
		var drink_number = jQuery('#drink_number').val();	 
		var drink_items = jQuery('#drink_items').val();	
		var drink_forward = jQuery('#drink_forward').val();	
		var drink_width = jQuery('#drink_width').val();	
		var drink_height = jQuery('#drink_height').val();	
		var drink_right = jQuery('#drink_right').val();	
		var drink_dir = jQuery('#drink_dir').val(); 
		var drink_auto=jQuery('#drink_auto').val();
		var drink_speed=jQuery('#drink_speed').val();
		var drink_cat=jQuery('#drink_cat').val();
		if(jQuery('#drink_auto').is(':checked'))	 
			{
			var drink_auto='true';
			} 
		if(jQuery('#drink_headline').is(':checked'))	 
			{
			var drink_headline='true';
			}
		if(jQuery('#drink_text').is(':checked'))	 
			{
			var drink_text='true';
			}
		if(jQuery('#drink_readmore').is(':checked'))	 
			{
			var drink_readmore='true';
			}
		if(jQuery('#drink_price').is(':checked'))	 
			{
			var drink_price='true';
			}
		var output = '';
		output = '[drinkslider type=\''+drink_cat+'\' speed=\''+drink_speed+'\' auto=\''+drink_auto+'\'  direction=\''+drink_dir+'\' items=\''+drink_items+'\' number=\''+drink_number+'\' itemsforward=\''+drink_forward+'\' width=\''+drink_width+'\' height=\''+drink_height+'\' right=\''+drink_right+'\' ]';			
		tinyMCEPopup.execCommand('mceInsertContent', false, output);
		tinyMCEPopup.close();
	}
};
tinyMCEPopup.onInit.add(DrinkDialog.init, DrinkDialog); 
</script>";
	}
add_action("shortcode_generator_scripts","add_drinkslider_shortcode_script");



/*
** DEFAULT METABOX
*/
add_action( 'add_meta_boxes', 'drinks_add_custom_box' ); 

function drinks_add_custom_box() 
	{
	add_meta_box( 'choose_your_options',  'Custom Options','cbg_inner_custom_box', 'drink','normal','high' ); 
	}




/*
** HELPER FUNCTIONS
*/

function get_the_drink_price()
	{
	global $post;
	$price_before=load_option("drinkprice_before");
	$price_after=load_option("drinkprice_after");
	$price_currency=load_option("drinkprice_currency");
	$price_position=load_option("drinkprice_position");
	$price=get_post_custom_values("drinkPrice");
	if($price_position=="after")
		{
		return $price_before." ".$price[0]. " ".$price_currency." ".$price_after;
		}
		else
			{
			return $price_before." ".$price_currency." ".$price[0]. " ".$price_after;
			}
	}

 

/*
** INGREDIENT LIST
*/

function get_drink_type_list()
	{
	return strip_tags( get_the_term_list( get_the_ID(), 'drink-type', "", ", " ));
	}








function drinks_single_entry($atts, $content=null)
	{
	global $default_button;
	extract(shortcode_atts(array( 
	'id'=>'',   
	    ), $atts));
	$return="";
	$cols="2";   
 	$args = array( 'posts_per_page' => '1', 'p'=>$id, 'post_type'=>'drink','post_status' => 'publish'); 
	$xpost = null;
	$xpost = new WP_Query($args); 
	$ix=0; 
	if( $xpost->have_posts() ) 
		{
		while ($xpost->have_posts()) : $xpost->the_post();  
		$ix++;  
	    	ob_start();  
	    	get_template_part("drink-entry");  
	    	$ret = ob_get_contents();  
	    	ob_end_clean();  
	   	$return.= $ret;  
	endwhile;
	}
	wp_reset_query();  
	return $return;		
	}
	add_shortcode('drink_single_entry', 'drinks_single_entry');



 



///////////////////
////// DRINKS LIST
///////////////////

function drink_simplelist($atts, $content=null)
	{
	extract(shortcode_atts(array(  
	'items'=>'-1',  
	'category'=>'',
	    ), $atts)); 
	$return="";
	$group_cat=""; 
	ob_start();
	?>
		<div class="group">
		<div class="portfolio-itemlist-col1 group-itemlist-1">
		<?php $ix=0; 
		query_posts(array( 'post_type' => 'drink', 'paged' => get_query_var('paged'), 'posts_per_page'=>$items ,   'drink-tag'=>$category ) ); 
		?>
		<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
			<?php $ix++; 
			$title= str_ireplace('"', '', trim(get_the_title()));
			$desc= str_ireplace('"', '', trim(get_the_content()));
 
			?>
			<div class="portfolio-lists-item">
				<?php get_template_part("drink-simplelist-item"); ?>
			</div>

		<?php 	 

			endwhile; 
		endif; ?>		 
		</div> 
		<div class="clear"></div>
	</div> 
	<?php 
    	$ret = ob_get_contents();  
    	ob_end_clean();  
	wp_reset_query(); 
	$return.=$ret;
	return $return;
	}
	add_shortcode("drink_simplelist","drink_simplelist");



































?>