<?php
/*
** This file contain all things for the meal post type, like shortcodes and functions
**
** To this posttype belongs this files:
**
** - meal-entry.php
** - meal-list-item.php
** - meal-menu-grid.php
** - meal-menu-list.php
** - meal-menu-simple-list.php
** - meal-simplelist-item.php
** - taxonomy-meal-type.php
**
*/





if ( function_exists( 'add_theme_support' ) ) 
	{ 
	add_theme_support( 'post-thumbnails' );
	set_post_thumbnail_size( 280, 210, true ); // Normal post thumbnails
	add_image_size( 'meal-mini', 330, 330, true );
	add_image_size( 'meal-default', 500, 500, true );
	add_image_size( 'meal-icon', 80, 80, true );
	}  
function meal_register() 
	{  
    	$args = array(  
        	'label' => 'Meals',  
        	'singular_label' => 'Meals',  
        	'public' => true,  
        	'show_ui' => true,  
        	'capability_type' => 'post',  
        	'hierarchical' => false,  
        	'rewrite' => true,  
        	'supports' => array('title', 'editor', 'thumbnail','post-types') ,
		'show_in_menu' => true  ,
		 'menu_position' => null,
       	);  
    	register_post_type( 'meal' , $args );  
	}  
	add_action('init', 'meal_register');  



register_taxonomy("meal-type", array("meal"), array("hierarchical" => true, "label" => "Ingredients", "singular_label" => "Meal Type", "rewrite" => true));
register_taxonomy("meal-tag", array("meal"), array("hierarchical" => true, "label" => "Category", "singular_label" => "Meal Type", "rewrite" => true));




function meal_mini_url($pid)
	{	
	$image_id = get_post_thumbnail_id($pid); 	
	$image_url = wp_get_attachment_image_src($image_id,'meal-mini'); 
	return  $image_url[0];  
	}
function meal_default_url($pid)
	{	
	$image_id = get_post_thumbnail_id($pid); 	
	$image_url = wp_get_attachment_image_src($image_id,'meal-default'); 
	return  $image_url[0];  
	}
function meal_icon_url($pid)
	{	
	$image_id = get_post_thumbnail_id($pid); 	
	$image_url = wp_get_attachment_image_src($image_id,'meal-icon'); 
	return  $image_url[0];  
	}





/*
** META BOX
*/


add_action("admin_init", "meal_meta_box"); 

function meal_meta_box()
	{  
	add_meta_box("mealInfo-meta", "Meal Options", "meal_meta_options", "meal", "side", "low");  
	}   
function meal_meta_options()
	{  
	        global $post;  
	        if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post_id;
	        $custom = get_post_custom($post->ID);  
		if(isset($custom["mealPrice"][0]))
			{
		             $name = $custom["mealPrice"][0];    
			}
		if(isset($custom["mealBestseller"][0]))
			{
		        	$bestseller = $custom["mealBestseller"][0];    		
			}
	?>  
	<ul>
		<li><label>Price: </label><input name="mealPrice" value="<?php if(isset($name)) { echo $name; } ?>" /></li>
		<li><label for="Bestseller"><input id="Bestseller" type="checkbox" name="Bestseller" <?php if(isset($bestseller)) { echo " checked"; }  ?> /> Mark as Bestseller</label></li>
	</ul>
	<?php  
	}  
	add_action('save_post', 'save_meal_meta');  
function save_meal_meta()
	{  
	    global $post;  
	    if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
		{ 
		return $post_id;
		}	
		else
			{
			if(isset($_POST["mealPrice"]))
				{
			    	update_post_meta($post->ID, "mealPrice", $_POST["mealPrice"]);  
				}
			if(isset($_POST["Bestseller"]))
				{
			    	update_post_meta($post->ID, "mealBestseller", $_POST["Bestseller"]);  		
				}
			} 
		}   







 




/*
** SHORTCODES
*/





///////////////////////
/////////// MEAL SLIDER
//////////////////////

function mealslider($atts, $content=null)
	{
	extract(shortcode_atts(array(
	'buttons'=>true,
	'speed'=>'1000',
	'width'=>'',
	'height'=>'',
	'easing'=>'',
	'items'=>'10',
	'price'=>'false',
	'itemsforward'=>'4',
	'pauseonhover'=>'true', 
	'direction'=>'left',
	'columns'=>'3',
	'showtext'=>'false',
	'readmore'=>'false',
	'headline'=>'false',
	'right'=>'20',
	'number'=>'10',
	'direction'=>'left',
	'category'=>'',
	'auto'=>'false', 
	    ), $atts));
	$return="";
	$ix="";
	if($speed=="")	
		{
		$speed="1000";
		}

	$price_name=load_option("price_name");
	$price_currency=load_option("price_currency");
	$rand=substr(str_shuffle(str_repeat('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz',5)),0,5);
	$return="<div id='carousel-".$rand."' class='carousel-container'>";
	$half_height=$height/2;	
	$return.="<style type='text/css' scoped><!-- #".$rand." .meal-lists-item-shortcode {display:inline-block; width:".$width."px; margin-right:".$right."px;}";
	$return.=" #carousel-".$rand."  .carousel-nav {top:".$half_height."px;}";
	if($height!="")
		{
		$return.=" #".$rand." {height:".$height."px;} #".$rand." > li, #".$rand." > div {  height:".$height."px;}";
		}
	if($width!="")
		{
		$return.=" #".$rand." > ul > li, #".$rand." > div {width:".$width."px; }";
		}
	$return.="--></style>";	
	if($buttons=="true")
		{	
		$return.="<a id='".$rand."-prev' class='carousel-nav carousel-nav-prev' onclick='return false' href='#'>&lt;</a>
			<a id='".$rand."-next' class='carousel-nav carousel-nav-next' onclick='return false' href='#'>&gt;</a>";
		}
	$return.="<ul class='carousel' id='".$rand."'>";



	switch ($columns)
		{
		case 1: $cols=""; break;
		case 2: $cols="one_half"; break;
		case 3: $cols="one_third"; break;
		case 4: $cols="one_fourth"; break; 
		}
	if($type!="")
		{
		$args = array( 'numberposts' => $number, 'post_type'=>'meal','post_status' => 'publish', 'meal-tag'=>$category);
		}
		else
			{
			$args = array( 'numberposts' => $number, 'post_type'=>'meal','post_status' => 'publish');
			}

	global $post;
	$myposts = get_posts( $args );
	foreach( $myposts as $post ) :	setup_postdata($post);  
	$ix++; 	
	$title= str_ireplace('"', '', trim(get_the_title()));
	$desc= str_ireplace('"', '', trim(get_the_content()));			 
	$return.='	<li class="ex-'.$cols.  ' meal-lists-item-shortcode">'; 
    	ob_start();  
    	get_template_part("meal-entry");  
    	$ret = ob_get_contents();  
    	ob_end_clean();  
   	$return.= $ret;   
	endforeach;
	wp_reset_query();
	$return.="</ul>";
	$return.="<script type='text/javascript'>
		<!--//--><![CDATA[//><!--
		jQuery(window).load(function()
			{
			jQuery('#carousel-".$rand." .carousel ').carouFredSel({
				items               	: ".$items.",
				direction           	: '".$direction."',
				";
			if($height!="")
				{
				$return.="height		: '".$height."', "; 
				}
	$return.="				
				prev		: '#".$rand."-prev',
				next		: '#".$rand."-next',";
	if($auto!="true")
		{
		$return.="
				auto :
					{
					play:	false 
					},
			";
		}
	$return.="		scroll : 
					{	";
	if($easing!="")
		{
		$return.="	easing		: '".$easing."', ";
		}
	$return.="
		            			items           : ".$itemsforward.",
		            			duration        : ".$speed.",                  
					easing		: 'easeInOutQuart',
	            				pauseOnHover    : true
	        				} 
				 });
			";
	if($height!="")
		{
		$return.="			jQuery('#".$rand."').parent().height('".$height."');";
		}
	$return.="
			});
		//--><!]]>
		</script>";
	$return.="</div>";
	$return.="<div class='clear'></div>";
	return $return;		
	}
	add_shortcode('mealslider', 'mealslider');


///////////////////
////// MEAL GRID
///////////////////

function meal_grid($atts, $content=null)
	{
	extract(shortcode_atts(array(  
	'items'=>'10', 
	'columns'=>'3', 
	'category'=>'',
	    ), $atts)); 
	$return="";
	$group_cat="";
	$cols=$columns;
	ob_start();
	?>
		<div class="group">
		<div class="portfolio-itemlist-col<?php echo $cols; ?> group-itemlist-<?php echo $cols; ?>">
		<?php $ix=0; 
		query_posts(array( 'post_type' => 'meal', 'paged' => get_query_var('paged'), 'posts_per_page'=>$items ,   'meal-tag'=>$category ) ); 
		?>
		<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
			<?php $ix++; ?>
			<?php
			if($ix>1)
				{
				$last="_last";
				$clear="<div class='clear'></div>";
				$ix=0;
				}
				else
					{
					$last="";	
					$clear="";
					}
			$title= str_ireplace('"', '', trim(get_the_title()));
			$desc= str_ireplace('"', '', trim(get_the_content()));
 
			?>
			<div class="portfolio-lists-item">
				<?php get_template_part("meal-entry"); ?>
			</div>

		<?php 	
			$clear="";
			if($ix>=$cols)
				{
				$ix=0;
				$clear=" clear";
				}

			endwhile; 
		endif; ?>		 
		</div><!-- portfolio-itemlist-col2 -->
		<div class="clear"></div>
	</div><!-- group-->  

	<?php 
    	$ret = ob_get_contents();  
    	ob_end_clean();  
	wp_reset_query(); 
	$return.=$ret;
	return $return;
	}
	add_shortcode("meal_grid","meal_grid");


function add_mealslider_shortcode()
	{
	echo '				<h3><a href="#">Meal Slider</a></h3>		
				<div>
					<label for="meal_number">Number of Items</label>
					<input type="text" name="meal_number" value="" id="meal_number" /><br />
					<label for="meal_items">Visible items</label>
					<input type="text" name="meal_items" value="" id="meal_items" /><br />	
					<label for="meal_forward">Number of Items go forward</label>
					<input type="text" name="meal_forward" value="" id="meal_forward" /><br />
					<label for="meal_width">Width of sliding element</label>
					<input type="text" name="meal_width" value="" id="meal_width" /><br />
					<label for="meal_height">Height of sliding element</label>
					<input type="text" name="meal_height" value="" id="meal_height" /><br />
					<label for="meal_right">Sliding element, distanze to the Right</label>
					<input type="text" name="meal_right" value="" id="meal_right" /><br />
					<label for="meal_headline">Show Headline?</label>
					<input type="checkbox" name="meal_headline" value="" id="meal_headline" /><br />
					<label for="meal_text">Show Text?</label>
					<input type="checkbox" name="meal_text" value="" id="meal_text" /><br />
					<label for="meal_readmore">Show Readmore Button?</label>
					<input type="checkbox" name="meal_readmore" value="" id="meal_readmore" /><br /> 
					<label for="meal_price">Show Price?</label>
					<input type="checkbox" name="meal_price" value="" id="meal_price" /><br /> 
					<label for="meal_dir">Direction</label>
					<select name="meal_dir" value="" id="meal_dir" >
						<option></option>
						<option value="left">Left</option>
						<option value="right">Right</option>
						<option value="up">Up</option>
						<option value="down">Down</option>
					</select>
					<label for="meal_auto">Autostart the Show?</label>
					<input type="checkbox" name="meal_auto" value="" id="meal_auto" /><br /> 
					<label for="meal_speed">Pause between Change in Millisecondes</label>
					<input type="text" name="meal_speed" id="meal_speed"><br />
					<label for="meal_cat">Show only Items from this Category:</label>
					<input type="text" name="meal_cat" id="meal_cat"><br />
					<br />
					<a href="javascript:MealDialog.insert(MealDialog.local_ed)" class="updateButton" style="display: block; line-height: 24px;">Insert</a>
				</div>';
	}
add_action("shortcode_generator_contentslider_tab","add_mealslider_shortcode");






function add_mealslider_shortcode_script()	
	{
	echo "<script type='text/javascript'> 
var MealDialog = {
	local_ed : 'ed',
	init : function(ed) {
	MealDialog.local_ed = ed;
		tinyMCEPopup.resizeToInnerSize();
	},
	insert : function insertmeal(ed) {
		var meal_number = jQuery('#meal_number').val();	 
		var meal_items = jQuery('#meal_items').val();	
		var meal_forward = jQuery('#meal_forward').val();	
		var meal_width = jQuery('#meal_width').val();	
		var meal_height = jQuery('#meal_height').val();	
		var meal_right = jQuery('#meal_right').val();	
		var meal_dir = jQuery('#meal_dir').val();
		var meal_auto=jQuery('#meal_auto').val();
		var meal_speed=jQuery('#meal_speed').val();
		var meal_cat=jQuery('#meal_cat').val();
		if(jQuery('#meal_auto').is(':checked'))	 
			{
			var meal_auto='true';
			} 
		if(jQuery('#meal_headline').is(':checked'))	 
			{
			var meal_headline='true';
			}
		if(jQuery('#meal_text').is(':checked'))	 
			{
			var meal_text='true';
			}
		if(jQuery('#meal_readmore').is(':checked'))	 
			{
			var meal_readmore='true';
			}
		if(jQuery('#meal_price').is(':checked'))	 
			{
			var meal_price='true';
			}
		var output = '';
		output = '[mealslider type=\''+meal_cat+'\' speed=\''+meal_speed+'\' auto=\''+meal_auto+'\'   direction=\''+meal_dir+'\' items=\''+meal_items+'\' number=\''+meal_number+'\' itemsforward=\''+meal_forward+'\' width=\''+meal_width+'\' height=\''+meal_height+'\' right=\''+meal_right+'\' ]';			
		tinyMCEPopup.execCommand('mceInsertContent', false, output);
		tinyMCEPopup.close();
	}
	};
	tinyMCEPopup.onInit.add(MealDialog.init, MealDialog); 
	</script>";
	}
add_action("shortcode_generator_scripts","add_mealslider_shortcode_script");


/*
** DEFAULT METABOX
*/
add_action( 'add_meta_boxes', 'meal_add_custom_box' ); 

function meal_add_custom_box() 
	{
	add_meta_box( 'choose_your_options',  'Custom Options','cbg_inner_custom_box', 'meal','normal','high' ); 
	}


/*
** HELPER FUNCTIONS
*/

function get_the_meal_price()
	{
	global $post;
	$price_before=load_option("price_before");
	$price_after=load_option("price_after");
	$price_currency=load_option("price_currency");
	$price_position=load_option("price_position");
	$price=get_post_custom_values("mealPrice");
	if($price_position=="after")
		{
		return $price_before." ".$price[0]. " ".$price_currency." ".$price_after;
		}
		else
			{
			return $price_before." ".$price_currency." ".$price[0]. " ".$price_after;
			}
	}

 

/*
** INGREDIENT LIST
*/

function get_meal_type_list()
	{
	return strip_tags( get_the_term_list( get_the_ID(), 'meal-type', "", ", " ));
	}








function meal_single_entry($atts, $content=null)
	{
	global $default_button;
	extract(shortcode_atts(array( 
	'id'=>'',   
	    ), $atts));
	$return="";
	$cols="2";   
 	$args = array( 'posts_per_page' => '1', 'p'=>$id, 'post_type'=>'meal','post_status' => 'publish'); 
	$xpost = null;
	$xpost = new WP_Query($args); 
	$ix=0; 
	if( $xpost->have_posts() ) 
		{
		while ($xpost->have_posts()) : $xpost->the_post();  
		$ix++;  
	    	ob_start();  
	    	get_template_part("meal-entry");  
	    	$ret = ob_get_contents();  
	    	ob_end_clean();  
	   	$return.= $ret;  
	endwhile;
	}
	wp_reset_query();  
	return $return;		
	}
	add_shortcode('meal_single_entry', 'meal_single_entry');


 




///////////////////
////// MEAL LIST
///////////////////

function meal_simplelist($atts, $content=null)
	{
	extract(shortcode_atts(array(  
	'items'=>'-1',  
	'category'=>'',
	    ), $atts)); 
	$return="";
	$group_cat=""; 
	ob_start();
	?>
		<div class="group">
		<div class="portfolio-itemlist-col1 group-itemlist-1">
		<?php $ix=0; 
		query_posts(array( 'post_type' => 'meal', 'paged' => get_query_var('paged'), 'posts_per_page'=>$items ,   'meal-tag'=>$category ) ); 
		?>
		<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
			<?php $ix++; 
			$title= str_ireplace('"', '', trim(get_the_title()));
			$desc= str_ireplace('"', '', trim(get_the_content()));
 
			?>
			<div class="portfolio-lists-item">
				<?php get_template_part("meal-simplelist-item"); ?>
			</div>

		<?php 	 

			endwhile; 
		endif; ?>		 
		</div> 
		<div class="clear"></div>
	</div> 
	<?php 
    	$ret = ob_get_contents();  
    	ob_end_clean();  
	wp_reset_query(); 
	$return.=$ret;
	return $return;
	}
	add_shortcode("meal_simplelist","meal_simplelist");




 
?>