<?php 
require_once ( get_template_directory() . '/7league/init.php' );
  


 
/* WOOCOMMERCE ACTIVATION */
if(load_option("woocommerce")=="on")
	{
	remove_action( 'woocommerce_before_main_content', 'woocommerce_output_content_wrapper', 10);
	remove_action( 'woocommerce_after_main_content', 'woocommerce_output_content_wrapper_end', 10);
	add_action('woocommerce_before_main_content', 'my_theme_wrapper_start', 10);
	add_action('woocommerce_after_main_content', 'my_theme_wrapper_end', 10);
	function my_theme_wrapper_start() 
		{
		echo '<section id="woo_main">';
		}
	function my_theme_wrapper_end() 
		{
		echo '</section>';
		}
	add_theme_support( 'woocommerce' );
	add_action( 'init', 'sevenleague_remove_wc_breadcrumbs' );
	function sevenleague_remove_wc_breadcrumbs() 
		{
		remove_action( 'woocommerce_before_main_content', 'woocommerce_breadcrumb', 20, 0 );
		} 
	remove_action('woocommerce_single_product_summary', 'woocommerce_template_single_title', 5);  
	}




















function prepare_headlines($content)
	{
	$content=str_replace("<h1>","<h1><span>",$content);
	$content=str_replace("</h1>","</span></h1>",$content);
	
	$content=str_replace("<h2>","<h2><span>",$content);
	$content=str_replace("</h2>","</span></h2>",$content);

	$content=str_replace("<h3>","<h3><span>",$content);
	$content=str_replace("</h3>","</span></h3>",$content);

	return $content;
	}

// add_filter('the_content','prepare_headlines');



load_theme_textdomain('sevenleague',get_template_directory() . '/languages');




 // Setup Theme Functions
 
function my_theme_setup() {	
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' ); 
	if ( ! isset( $content_width ) ) $content_width = 980;		 
 
	// POST FORMATS

	add_theme_support( 'post-formats', array( 'video', 'audio', 'image', 'gallery','quote', 'link' ) );

	// ADD FILTERS 
	add_filter( 'excerpt_length', 'the_excerpt_length' );
	add_filter( 'get_the_excerpt', 'custom_excerpt_more' ); 
	add_filter( 'excerpt_more', 'auto_excerpt_more' );

	// REGISTER THE MENU 
	register_nav_menus(
		array(
		  'main_menu_1' => 'The Main Menu' 
		)
	);
    } 
add_action('after_setup_theme', 'my_theme_setup');





 function the_excerpt_length( $length ) 
	{
	return 50;
	}


function continue_reading_link() 
	{
	return ' <a href="'. esc_url( get_permalink() ) . '"><span class="meta-nav">...</span></a>';
	}


function auto_excerpt_more( $more ) 
	{
	return continue_reading_link();
	}


function custom_excerpt_more( $output ) 
	{
	if ( has_excerpt() && ! is_attachment() ) 
		{
		$output .=  continue_reading_link();
		}
		return $output;
	}










/*
** THE COMMENTSTEMPLATE
*/
function mytheme_comment($comment, $args, $depth) 
	{
	$GLOBALS['comment'] = $comment; ?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
		<article id="comment-<?php comment_ID(); ?>" class="comment-body">
			<footer class="comment-author vcard">
				<?php echo get_avatar( $comment->comment_author_email, 60 ); ?>
				<p class='commentauthor'><?php  comment_author_link(); ?></p>
				<p class='comment-time'><?php comment_date(); ?>, <?php comment_time(); ?></p>							
			</footer>
			<div class="comments-body">				
				<?php comment_text() ?>
				<div class="reply">
					<?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?> | <?php edit_comment_link('Edit','  ','') ?>
 				</div>
				<?php if ($comment->comment_approved == '0') : ?>
					<em><?php _e('Your comment is awaiting moderation.','sevenleague'); ?></em>			
				<?php endif; ?>
			</div>
			<div class="clear"></div>
		</article>
	</li>
	<?php
   	}












class Menu_With_Description extends Walker_Nav_Menu 
	{
    	function display_element( $element, &$children_elements, $max_depth, $depth=0, $args, &$output )
    		{
        		$id_field = $this->db_fields['id'];
        			if ( is_object( $args[0] ) ) 
				{
            				$args[0]->has_children = ! empty( $children_elements[$element->$id_field] );
				}
        		return parent::display_element( $element, $children_elements, $max_depth, $depth, $args, $output );
    		}
	function start_el(&$output, $item, $depth, $args ) 
		{
		global $wp_query;
		$item_output="";
		$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
		$class_names = $value = '';
		$classes = empty( $item->classes ) ? array() : (array) $item->classes;
 		if( $args->has_children ) 
			{ 
			$classes[]="has-submenu"; 
			}
		if(is_numeric($item->xfn))
			{
			$classes[]="static-item";
			}
		$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item ) );
		$class_names = ' class="' . esc_attr( $class_names ) . '"';
		$output .= $indent . '<li id="menu-item-'. $item->ID . '"' . $value . $class_names .'>'; 
		$attributes = ! empty( $item->attr_title ) ? ' title="' . esc_attr( $item->attr_title ) .'"' : '';
		$attributes .= ! empty( $item->target ) ? ' target="' . esc_attr( $item->target ) .'"' : '';
		// $attributes .= ! empty( $item->xfn ) ? ' rel="' . esc_attr( $item->xfn ) .'"' : '';
		$attributes .= ! empty( $item->url ) ? ' href="' . esc_attr( $item->url ) .'"' : '';

	$menuicon=get_post_custom_values("menuicon",$item->object_id);
	if($menuicon[0]!="")
		{
		$item_output .= "<i class='icon-".$menuicon[0]."'></i>";
		}

		if (trim($item->description)!="")
			{
			$attributes .= ! empty( $item->description) ? ' data-v="'.esc_Attr($item->description).'"' : '';
			}
		$item_output .= $args->before;
		$item_output .= '<a'. $attributes .'>';
		$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after ;
		//$item_output .= '<b>' . $item->description . '</b>';
		//$item_output .= '<em></em>';
		if (trim($item->description)!="")
			{
			$item_output.='<span>'.$item->description.'</span>';
			}
		$item_output .= '</a>';
		if(is_numeric($item->xfn))
			{
			$pid = $item->xfn;
			$page_object = get_post( $pid );
			$item_output .=  "<div class='seven_mega_menu'>".apply_filters('the_content', $page_object->post_content)."</div>";
			}
		$item_output .= $args->after;
		$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
	}
}  









function wr_wp_get_attachment( $attachment_id ) {

	$attachment = get_post( $attachment_id );
	return array(
		'alt' => get_post_meta( $attachment->ID, '_wp_attachment_image_alt', true ),
		'caption' => $attachment->post_excerpt,
		'description' => $attachment->post_content,
		'href' => get_permalink( $attachment->ID ),
		'src' => $attachment->guid,
		'title' => $attachment->post_title
	);
}

 


/*
** MENU ICON 
*/

function add_menuicon_tab()
	{
	echo "<li><a href='#menuicon'>Menu</a></li>";	
	}
add_action("sevenleague_add_to_metabox_tablist", "add_menuicon_tab");





function add_menuicon_tab_content()
	{
	global $fa_icons;
	$menuicon=get_post_custom_values("menuicon");
	?>
	<div id="menuicon">
		 <div class="options-line">
			<div class="options-left"><label for="menuicon">The icon for the menu</label></div>
		       	<div class="options-right">  
 				<?php echo icons_dropdown($id="menuicon", $name="menuicon", $value=$menuicon[0]);  ?>
			</div> 	
		</div> 

	</div>
	<?php
	}
add_action("sevenleague_add_to_metabox_tabs","add_menuicon_tab_content");






function save_menuicon()
	{
	global $post;
	if(isset($_POST["menuicon"]))
		{
    		update_post_meta($post->ID, "menuicon", $_POST["menuicon"]);
		} 
	}

add_action("sevenleague_save_custom_meta","save_menuicon");



